\documentclass[11pt, a4paper]{article}


\usepackage{url}
% DOCUMENT LAYOUT
\usepackage[margin=1in]{geometry}
\parindent=15pt

% Reduce spacing in enumerate, enumerate and titles
\usepackage{multicol}
\usepackage{enumitem}
\setenumerate{nolistsep}
\setenumerate{nolistsep}
% \setlength{\parskip}{1em}

% FONTS
\usepackage[utf8]{inputenc}

% HEADINGS and TITLES
\usepackage{sectsty}
\usepackage[normalem]{ulem}

% packages
\usepackage{amsmath, amsfonts, latexsym, listings, cite, amssymb,
  amsthm, stmaryrd, scrextend, float, mathtools}

\usepackage{graphicx}
\graphicspath{ {./img/} }

% Not native to tex
\usepackage{bussproofs}
\usepackage{qtree}
\usepackage{tikz-cd}

\usepackage{titling}
\setlength{\droptitle}{-90pt}
\title{CS5350: Reading Response 6}
\author{ Jamil Gafur}

% BEGIN DOCUMENT
\begin{document}
\maketitle


\section{Random permutation Definition}

State precisely what we mean by a random permutation.

\vspace{.2in}
\hline
\vspace{.2in}
Given a method ``RandomPermutation'' that takes in a list and returns a random permutation of that list, we can define a random permutation as follows:

Define: $Q$ such that Q contains all possible combinations of the list. We return a single element in $Q$ where each element has an equal probability of being selected.\\\newline
ex: input list = [1,2,3]\\
Q = [[1,2,3],[1,3,2],[2,3,1],[2,1,3],[3,2,1],[3,1,2]]\\
where $\forall e \in Q, e $ has a $\mathbb{P}(\frac{1}{len(Q)})$ of being returned


\section{Algorithm Analysis}

Given the Algorithm:

Consider elements in L in the order L[n], $\dots$, L[1]. When element L[i] is considered, generate an index uniformly at random from the set [i, $\dots$, n] and swap the elements at index i and j.

Explain why this is a random permutation.

\vspace{.2in}
\hline
\vspace{.2in}
This algorithm is a random permutation because it cycles through each element and attempts to swap it with another random element for this reason any permutation is possible (therefore we can generate Q).

The next step is that each permutation is equally likely to be returned. We can see that there are $n(n-1)(n-2)\dots$ possible combinations of random j values. This means that each permutation has a $\mathbb{P}(\frac{1}{n!})$ of being returned


\end{document}
